
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Discrepancy_casesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const discrepancy_cases = await db.discrepancy_cases.create(
            {
                id: data.id || undefined,
        
        type: data.type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        reported_at: data.reported_at
        ||
        null
            ,
            
        resolved_at: data.resolved_at
        ||
        null
            ,
            
        resolution_notes: data.resolution_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await discrepancy_cases.setTenant( data.tenant || null, {
            transaction,
        });
        
        await discrepancy_cases.setPurchase_order( data.purchase_order || null, {
            transaction,
        });
        
        await discrepancy_cases.setGoods_receipt_note( data.goods_receipt_note || null, {
            transaction,
        });
        
        await discrepancy_cases.setReported_by( data.reported_by || null, {
            transaction,
        });
        
        await discrepancy_cases.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.discrepancy_cases.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: discrepancy_cases.id,
            },
            data.photos,
            options,
        );
        

        return discrepancy_cases;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const discrepancy_casesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                type: item.type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                reported_at: item.reported_at
            ||
            null
            ,
            
                resolved_at: item.resolved_at
            ||
            null
            ,
            
                resolution_notes: item.resolution_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const discrepancy_cases = await db.discrepancy_cases.bulkCreate(discrepancy_casesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < discrepancy_cases.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.discrepancy_cases.getTableName(),
                    belongsToColumn: 'photos',
                    belongsToId: discrepancy_cases[i].id,
                },
                data[i].photos,
                options,
            );
        }
        

        return discrepancy_cases;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const discrepancy_cases = await db.discrepancy_cases.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.type !== undefined) updatePayload.type = data.type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.reported_at !== undefined) updatePayload.reported_at = data.reported_at;
        
        
        if (data.resolved_at !== undefined) updatePayload.resolved_at = data.resolved_at;
        
        
        if (data.resolution_notes !== undefined) updatePayload.resolution_notes = data.resolution_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await discrepancy_cases.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await discrepancy_cases.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.purchase_order !== undefined) {
            await discrepancy_cases.setPurchase_order(
              
              data.purchase_order,
              
              { transaction }
            );
        }
        
        if (data.goods_receipt_note !== undefined) {
            await discrepancy_cases.setGoods_receipt_note(
              
              data.goods_receipt_note,
              
              { transaction }
            );
        }
        
        if (data.reported_by !== undefined) {
            await discrepancy_cases.setReported_by(
              
              data.reported_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await discrepancy_cases.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.discrepancy_cases.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: discrepancy_cases.id,
            },
            data.photos,
            options,
        );
        

        return discrepancy_cases;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const discrepancy_cases = await db.discrepancy_cases.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of discrepancy_cases) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of discrepancy_cases) {
                await record.destroy({transaction});
            }
        });


        return discrepancy_cases;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const discrepancy_cases = await db.discrepancy_cases.findByPk(id, options);

        await discrepancy_cases.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await discrepancy_cases.destroy({
            transaction
        });

        return discrepancy_cases;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const discrepancy_cases = await db.discrepancy_cases.findOne(
            { where },
            { transaction },
        );

        if (!discrepancy_cases) {
            return discrepancy_cases;
        }

        const output = discrepancy_cases.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await discrepancy_cases.getTenant({
            transaction
        });
        
        
        output.purchase_order = await discrepancy_cases.getPurchase_order({
            transaction
        });
        
        
        output.goods_receipt_note = await discrepancy_cases.getGoods_receipt_note({
            transaction
        });
        
        
        output.photos = await discrepancy_cases.getPhotos({
            transaction
        });
        
        
        output.reported_by = await discrepancy_cases.getReported_by({
            transaction
        });
        
        
        output.organizations = await discrepancy_cases.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.purchase_orders,
        as: 'purchase_order',
        
        where: filter.purchase_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.purchase_order.split('|').map(term => Utils.uuid(term)) } },
            {
              po_number: {
                [Op.or]: filter.purchase_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.goods_receipt_notes,
        as: 'goods_receipt_note',
        
        where: filter.goods_receipt_note ? {
          [Op.or]: [
            { id: { [Op.in]: filter.goods_receipt_note.split('|').map(term => Utils.uuid(term)) } },
            {
              grn_number: {
                [Op.or]: filter.goods_receipt_note.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reported_by',
        
        where: filter.reported_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reported_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reported_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'photos',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'discrepancy_cases',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.resolution_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'discrepancy_cases',
                        'resolution_notes',
                        filter.resolution_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.reported_atRange) {
                const [start, end] = filter.reported_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.resolved_atRange) {
                const [start, end] = filter.resolved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    resolved_at: {
                    ...where.resolved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    resolved_at: {
                    ...where.resolved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.type) {
                where = {
                    ...where,
                type: filter.type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.discrepancy_cases.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'discrepancy_cases',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.discrepancy_cases.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

